Index: client/src/main/java/org/teiid/jdbc/DatabaseMetaDataImpl.java
===================================================================
--- client/src/main/java/org/teiid/jdbc/DatabaseMetaDataImpl.java	(revision 3801)
+++ client/src/main/java/org/teiid/jdbc/DatabaseMetaDataImpl.java	(working copy)
@@ -1630,13 +1633,13 @@
                 JDBCColumnNames.UDTS.BASE_TYPE
         };
         String[] dataTypes = new String[] {
-                JDBCSQLTypeInfo.STRING,
-                JDBCSQLTypeInfo.STRING,
-                JDBCSQLTypeInfo.STRING,
-                JDBCSQLTypeInfo.STRING,
-                JDBCSQLTypeInfo.STRING, 
-                JDBCSQLTypeInfo.STRING,
-                JDBCSQLTypeInfo.SHORT                
+                DataTypeManager.DefaultDataTypes.STRING,
+                DataTypeManager.DefaultDataTypes.STRING,
+                DataTypeManager.DefaultDataTypes.STRING,
+                DataTypeManager.DefaultDataTypes.STRING,
+                DataTypeManager.DefaultDataTypes.STRING, 
+                DataTypeManager.DefaultDataTypes.STRING,
+                DataTypeManager.DefaultDataTypes.SHORT                
         };       
         return dummyStatement().createResultSet(Collections.EMPTY_LIST, columnNames, dataTypes);
     }
Index: client/src/main/java/org/teiid/client/ResultsMessage.java
===================================================================
--- client/src/main/java/org/teiid/client/ResultsMessage.java	(revision 3801)
+++ client/src/main/java/org/teiid/client/ResultsMessage.java	(working copy)
@@ -242,7 +242,7 @@
         dataTypes = ExternalizeUtil.readStringArray(in);
 
         // Row data
-        results = BatchSerializer.readBatch(in, dataTypes, (byte)0);
+        results = BatchSerializer.readBatch(in, dataTypes);
 
         // Plan Descriptions
         planDescription = (PlanNode)in.readObject();
@@ -274,7 +274,7 @@
         ExternalizeUtil.writeArray(out, dataTypes);
 
         // Results data
-        BatchSerializer.writeBatch(out, dataTypes, results, (byte)0);
+        BatchSerializer.writeBatch(out, dataTypes, results, clientSerializationVersion);
 
         // Plan descriptions
         out.writeObject(this.planDescription);
Index: client/src/test/java/org/teiid/jdbc/TestCallableStatement.java
===================================================================
--- client/src/test/java/org/teiid/jdbc/TestCallableStatement.java	(revision 3801)
+++ client/src/test/java/org/teiid/jdbc/TestCallableStatement.java	(working copy)
@@ -38,7 +38,7 @@
 import org.teiid.client.ResultsMessage;
 import org.teiid.client.metadata.ParameterInfo;
 import org.teiid.client.security.LogonResult;
-import org.teiid.core.types.JDBCSQLTypeInfo;
+import org.teiid.core.types.DataTypeManager;
 import org.teiid.net.ServerConnection;
 
 @SuppressWarnings("nls")
@@ -70,7 +70,7 @@
 		List<?>[] results = new List[] {Arrays.asList(null, null, null), Arrays.asList(null, 1, 2)};
 		resultsMsg.setResults(results);
 		resultsMsg.setColumnNames(new String[] { "IntNum", "Out1", "Out2" }); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-		resultsMsg.setDataTypes(new String[] { JDBCSQLTypeInfo.INTEGER, JDBCSQLTypeInfo.INTEGER, JDBCSQLTypeInfo.INTEGER }); 
+		resultsMsg.setDataTypes(new String[] { DataTypeManager.DefaultDataTypes.INTEGER, DataTypeManager.DefaultDataTypes.INTEGER, DataTypeManager.DefaultDataTypes.INTEGER }); 
 		resultsMsg.setFinalRow(results.length);
 		resultsMsg.setLastRow(results.length);
 		resultsMsg.setFirstRow(1);
Index: common-core/src/main/java/org/teiid/core/types/basic/ClobToStringTransform.java
===================================================================
--- common-core/src/main/java/org/teiid/core/types/basic/ClobToStringTransform.java	(revision 3801)
+++ common-core/src/main/java/org/teiid/core/types/basic/ClobToStringTransform.java	(working copy)
@@ -49,9 +49,9 @@
      */
     public Object transformDirect(Object value) throws TransformationException {
         ClobType source = (ClobType)value;
-        
+        BufferedReader reader = null;
         try {
-            BufferedReader reader = new BufferedReader (source.getCharacterStream());
+            reader = new BufferedReader (source.getCharacterStream());
             StringBuffer contents = new StringBuffer();
             
             int chr = reader.read();
@@ -59,14 +59,19 @@
                 contents.append((char)chr);
                 chr = reader.read();
             }
-            reader.close();
             return contents.toString();         
-            
         } catch (SQLException e) {
             throw new TransformationException(e, CorePlugin.Util.getString("failed_convert", new Object[] {getSourceType().getName(), getTargetType().getName()})); //$NON-NLS-1$            
         } catch(IOException e) {
             throw new TransformationException(e, CorePlugin.Util.getString("failed_convert", new Object[] {getSourceType().getName(), getTargetType().getName()})); //$NON-NLS-1$
-        } 
+        } finally {
+        	if (reader != null) {
+        		try {
+					reader.close();
+				} catch (IOException e) {
+				}
+        	}
+        }
     }
 
     /** 
Index: common-core/src/main/java/org/teiid/core/types/JDBCSQLTypeInfo.java
===================================================================
--- common-core/src/main/java/org/teiid/core/types/JDBCSQLTypeInfo.java	(revision 3801)
+++ common-core/src/main/java/org/teiid/core/types/JDBCSQLTypeInfo.java	(working copy)
@@ -25,10 +25,11 @@
 import java.sql.Blob;
 import java.sql.Clob;
 import java.sql.SQLXML;
-
 import java.sql.Types;
 import java.util.HashMap;
+import java.util.LinkedHashMap;
 import java.util.Map;
+import java.util.Set;
 
 /**
  * <p> This is a helper class used to obtain SQL type information for java types.
@@ -37,99 +38,82 @@
  */
 
 public final class JDBCSQLTypeInfo {
-
-
+	
+	public static class TypeInfo {
+		String name;
+		int maxDisplaySize;
+		int defaultPrecision;
+		String javaClassName;
+		int[] jdbcTypes;
+		
+		public TypeInfo(int maxDisplaySize, int precision, String name,
+				String javaClassName, int[] jdbcTypes) {
+			super();
+			this.maxDisplaySize = maxDisplaySize;
+			this.defaultPrecision = precision;
+			this.name = name;
+			this.javaClassName = javaClassName;
+			this.jdbcTypes = jdbcTypes;
+		}
+		
+	}
+	
     // Prevent instantiation
     private JDBCSQLTypeInfo() {}
-    
-    // metamatrix types    
-    public static final String STRING = DataTypeManager.DefaultDataTypes.STRING;
-    public static final String BOOLEAN = DataTypeManager.DefaultDataTypes.BOOLEAN;
-    public static final String TIME = DataTypeManager.DefaultDataTypes.TIME;
-    public static final String DATE = DataTypeManager.DefaultDataTypes.DATE;
-    public static final String TIMESTAMP = DataTypeManager.DefaultDataTypes.TIMESTAMP;
-    public static final String INTEGER = DataTypeManager.DefaultDataTypes.INTEGER;
-    public static final String FLOAT = DataTypeManager.DefaultDataTypes.FLOAT;
-    public static final String DOUBLE = DataTypeManager.DefaultDataTypes.DOUBLE;
-    public static final String BIGDECIMAL = DataTypeManager.DefaultDataTypes.BIG_DECIMAL;
-    public static final String BIGINTEGER = DataTypeManager.DefaultDataTypes.BIG_INTEGER;
-    public static final String BYTE = DataTypeManager.DefaultDataTypes.BYTE;
-    public static final String SHORT = DataTypeManager.DefaultDataTypes.SHORT;
-    public static final String LONG = DataTypeManager.DefaultDataTypes.LONG;
-    public static final String CHAR = DataTypeManager.DefaultDataTypes.CHAR;
-    public static final String OBJECT = DataTypeManager.DefaultDataTypes.OBJECT;
-    public static final String CLOB = DataTypeManager.DefaultDataTypes.CLOB;
-    public static final String BLOB = DataTypeManager.DefaultDataTypes.BLOB;
-    public static final String XML = DataTypeManager.DefaultDataTypes.XML;
-    public static final String NULL = DataTypeManager.DefaultDataTypes.NULL;
-    
-    //java class names
-    public static final String STRING_CLASS = DataTypeManager.DefaultDataClasses.STRING.getName();
-    public static final String BOOLEAN_CLASS = DataTypeManager.DefaultDataClasses.BOOLEAN.getName();
-    public static final String TIME_CLASS = DataTypeManager.DefaultDataClasses.TIME.getName();
-    public static final String DATE_CLASS = DataTypeManager.DefaultDataClasses.DATE.getName();
-    public static final String TIMESTAMP_CLASS = DataTypeManager.DefaultDataClasses.TIMESTAMP.getName();
-    public static final String INTEGER_CLASS = DataTypeManager.DefaultDataClasses.INTEGER.getName();
-    public static final String FLOAT_CLASS = DataTypeManager.DefaultDataClasses.FLOAT.getName();
-    public static final String DOUBLE_CLASS = DataTypeManager.DefaultDataClasses.DOUBLE.getName();
-    public static final String BIGDECIMAL_CLASS = DataTypeManager.DefaultDataClasses.BIG_DECIMAL.getName();
-    public static final String BYTE_CLASS = DataTypeManager.DefaultDataClasses.BYTE.getName();
-    public static final String SHORT_CLASS = DataTypeManager.DefaultDataClasses.SHORT.getName();
-    public static final String LONG_CLASS = DataTypeManager.DefaultDataClasses.LONG.getName();
-    public static final String CHAR_CLASS = DataTypeManager.DefaultDataClasses.CHAR.getName();
-    public static final String BIGINTEGER_CLASS = DataTypeManager.DefaultDataClasses.BIG_INTEGER.getName();
-    public static final String OBJECT_CLASS = DataTypeManager.DefaultDataClasses.OBJECT.getName();
-    public static final String CLOB_CLASS = Clob.class.getName();
-    public static final String BLOB_CLASS = Blob.class.getName();
-    public static final String XML_CLASS = SQLXML.class.getName();
-    
-    private static Map<String, Integer> NAME_TO_TYPE_MAP = new HashMap<String, Integer>();
-    private static Map<Integer, String> TYPE_TO_NAME_MAP = new HashMap<Integer, String>();
-    private static Map<String, String> NAME_TO_CLASSNAME = new HashMap<String, String>();
-    private static Map<String, String> CLASSNAME_TO_NAME = new HashMap<String, String>();
-    
+
+    public static final Integer DEFAULT_RADIX = 10;
+    public static final Integer DEFAULT_SCALE = 0;
+
+    // XML column constants
+    public final static Integer XML_COLUMN_LENGTH = Integer.MAX_VALUE;
+
+    private static Map<String, TypeInfo> NAME_TO_TYPEINFO = new LinkedHashMap<String, TypeInfo>();
+    private static Map<Integer, TypeInfo> TYPE_TO_TYPEINFO = new HashMap<Integer, TypeInfo>();
+    private static Map<String, TypeInfo> CLASSNAME_TO_TYPEINFO = new HashMap<String, TypeInfo>();
+
     static {
-        addTypeMapping(STRING, STRING_CLASS, Types.VARCHAR, Types.CHAR, Types.NVARCHAR, Types.NCHAR);
-        addTypeMapping(CHAR, CHAR_CLASS, Types.CHAR, false);
-        addTypeMapping(BOOLEAN, BOOLEAN_CLASS, Types.BIT, Types.BOOLEAN);
-        addTypeMapping(TIME, TIME_CLASS, Types.TIME);
-        addTypeMapping(DATE, DATE_CLASS, Types.DATE);
-        addTypeMapping(TIMESTAMP, TIMESTAMP_CLASS, Types.TIMESTAMP);
-        addTypeMapping(INTEGER, INTEGER_CLASS, Types.INTEGER);
-        addTypeMapping(FLOAT, FLOAT_CLASS, Types.REAL);
-        addTypeMapping(DOUBLE, DOUBLE_CLASS, Types.DOUBLE, Types.FLOAT);
-        addTypeMapping(BIGDECIMAL, BIGDECIMAL_CLASS, Types.NUMERIC, Types.DECIMAL);
-        addTypeMapping(BIGINTEGER, BIGINTEGER_CLASS, Types.NUMERIC, false);
-        addTypeMapping(BYTE, BYTE_CLASS, Types.TINYINT);
-        addTypeMapping(SHORT, SHORT_CLASS, Types.SMALLINT);
-        addTypeMapping(LONG, LONG_CLASS, Types.BIGINT);
-        addTypeMapping(OBJECT, OBJECT_CLASS, Types.JAVA_OBJECT);
-        addTypeMapping(CLOB, CLOB_CLASS, Types.CLOB, Types.LONGVARCHAR, Types.LONGNVARCHAR, Types.NCLOB);
-        addTypeMapping(BLOB, BLOB_CLASS, Types.BLOB, Types.BINARY, Types.VARBINARY, Types.LONGVARBINARY);
-        
-        addTypeMapping(NULL, null, Types.NULL);
-        
-        addTypeMapping(XML, XML_CLASS, Types.SQLXML);
+    	//note the order in which these are added matters.  if there are multiple sql type mappings (e.g. biginteger and bigdecimal to numeric), the latter will be the primary
+    	addType(DataTypeManager.DefaultDataTypes.BIG_INTEGER, 20, 19, DataTypeManager.DefaultDataClasses.BIG_INTEGER.getName(), Types.NUMERIC);
+    	addType(new String[] {DataTypeManager.DefaultDataTypes.BIG_DECIMAL, "decimal"}, 22, 20, DataTypeManager.DefaultDataClasses.BIG_DECIMAL.getName(), Types.NUMERIC, Types.DECIMAL); //$NON-NLS-1$
+    	addType(DataTypeManager.DefaultDataTypes.BLOB, Integer.MAX_VALUE, Integer.MAX_VALUE, Blob.class.getName(), Types.BLOB, Types.LONGVARBINARY);
+    	addType(DataTypeManager.DefaultDataTypes.BOOLEAN, 5, 1, DataTypeManager.DefaultDataClasses.BOOLEAN.getName(), Types.BIT, Types.BOOLEAN);
+    	addType(new String[] {DataTypeManager.DefaultDataTypes.BYTE, "tinyint"}, 4, 3, DataTypeManager.DefaultDataClasses.BYTE.getName(), Types.TINYINT); //$NON-NLS-1$
+    	addType(DataTypeManager.DefaultDataTypes.CHAR, 1, 1, DataTypeManager.DefaultDataClasses.CHAR.getName(), Types.CHAR);
+    	addType(DataTypeManager.DefaultDataTypes.CLOB, Integer.MAX_VALUE, Integer.MAX_VALUE, Clob.class.getName(), Types.CLOB, Types.NCLOB, Types.LONGNVARCHAR, Types.LONGVARCHAR);
+    	addType(DataTypeManager.DefaultDataTypes.DATE, 10, 10, DataTypeManager.DefaultDataClasses.DATE.getName(), Types.DATE);
+    	addType(DataTypeManager.DefaultDataTypes.DOUBLE, 22, 20, DataTypeManager.DefaultDataClasses.DOUBLE.getName(), Types.DOUBLE, Types.FLOAT);
+    	addType(new String[] {DataTypeManager.DefaultDataTypes.FLOAT, "real"}, 22, 20, DataTypeManager.DefaultDataClasses.FLOAT.getName(), Types.REAL); //$NON-NLS-1$
+    	addType(DataTypeManager.DefaultDataTypes.INTEGER, 11, 10, DataTypeManager.DefaultDataClasses.INTEGER.getName(), Types.INTEGER);
+    	addType(new String[] {DataTypeManager.DefaultDataTypes.LONG, "bigint"}, 20, 19, DataTypeManager.DefaultDataClasses.LONG.getName(), Types.BIGINT); //$NON-NLS-1$
+    	addType(DataTypeManager.DefaultDataTypes.OBJECT, Integer.MAX_VALUE, Integer.MAX_VALUE, DataTypeManager.DefaultDataClasses.OBJECT.getName(), Types.JAVA_OBJECT);
+    	addType(new String[] {DataTypeManager.DefaultDataTypes.SHORT, "smallint"}, 6, 5, DataTypeManager.DefaultDataClasses.SHORT.getName(), Types.SMALLINT); //$NON-NLS-1$
+    	addType(new String[] {DataTypeManager.DefaultDataTypes.STRING, "varchar"}, DataTypeManager.MAX_STRING_LENGTH, DataTypeManager.MAX_STRING_LENGTH, DataTypeManager.DefaultDataClasses.STRING.getName(), Types.VARCHAR, Types.NVARCHAR, Types.CHAR, Types.NCHAR); //$NON-NLS-1$
+    	addType(DataTypeManager.DefaultDataTypes.TIME, 8, 8, DataTypeManager.DefaultDataClasses.TIME.getName(), Types.TIME);
+    	addType(DataTypeManager.DefaultDataTypes.TIMESTAMP, 29, 29, DataTypeManager.DefaultDataClasses.TIMESTAMP.getName(), Types.TIMESTAMP);
+    	addType(DataTypeManager.DefaultDataTypes.XML, Integer.MAX_VALUE, Integer.MAX_VALUE, SQLXML.class.getName(), Types.SQLXML);
+    	addType(DataTypeManager.DefaultDataTypes.NULL, 4, 1, null, Types.NULL);
+    	addType(DataTypeManager.DefaultDataTypes.VARBINARY, DataTypeManager.MAX_LOB_MEMORY_BYTES, DataTypeManager.MAX_LOB_MEMORY_BYTES, byte[].class.getName(), Types.VARBINARY, Types.BINARY);
     }
 
-	private static void addTypeMapping(String typeName, String javaClass, int sqlType, int ... secondaryTypes) {
-		addTypeMapping(typeName, javaClass, sqlType, true);
-		for (int type : secondaryTypes) {
-			TYPE_TO_NAME_MAP.put(type, typeName);
+	private static TypeInfo addType(String typeName, int maxDisplaySize, int precision, String javaClassName, int... sqlTypes) {
+		TypeInfo ti = new TypeInfo(maxDisplaySize, precision, typeName, javaClassName, sqlTypes);
+		NAME_TO_TYPEINFO.put(typeName, ti);
+		if (javaClassName != null) {
+			CLASSNAME_TO_TYPEINFO.put(javaClassName, ti);
 		}
-	}
-
-	private static void addTypeMapping(String typeName, String javaClass, int sqlType, boolean preferedType) {
-		NAME_TO_TYPE_MAP.put(typeName, sqlType);
-		if (preferedType) {
-			TYPE_TO_NAME_MAP.put(sqlType, typeName);
+		for (int i : sqlTypes) {
+			TYPE_TO_TYPEINFO.put(i, ti);
 		}
-		if (javaClass != null) {
-			NAME_TO_CLASSNAME.put(typeName, javaClass);
-			CLASSNAME_TO_NAME.put(javaClass, typeName);
+		return ti;
+	}
+	
+	private static void addType(String[] typeNames, int maxDisplaySize, int precision, String javaClassName, int... sqlTypes) {
+		TypeInfo ti = addType(typeNames[0], maxDisplaySize, precision, javaClassName, sqlTypes);
+		for (int i = 1; i < typeNames.length; i++) {
+			NAME_TO_TYPEINFO.put(typeNames[i], ti);
 		}
 	}
-    
+
     /**
      * This method is used to obtain a short indicating JDBC SQL type for any object.
      * The short values that give the type info are from java.sql.Types.
@@ -142,13 +126,13 @@
             return Types.NULL;
         }
         
-        Integer sqlType = NAME_TO_TYPE_MAP.get(typeName);
+        TypeInfo sqlType = NAME_TO_TYPEINFO.get(typeName);
         
         if (sqlType == null) {
             return Types.JAVA_OBJECT;
         }
         
-        return sqlType.intValue();
+        return sqlType.jdbcTypes[0];
     }    
 
     /**
@@ -163,13 +147,13 @@
             return Types.NULL;
         }
         
-        String name = CLASSNAME_TO_NAME.get(className);
+        TypeInfo sqlType = CLASSNAME_TO_TYPEINFO.get(className);
         
-        if (name == null) {
+        if (sqlType == null) {
             return Types.JAVA_OBJECT;
         }
         
-        return getSQLType(name);
+        return sqlType.jdbcTypes[0];
     } 
     
     /**
@@ -199,46 +183,51 @@
      * @return A String representing the java class name for the given SQL Type.
      */
     public static final String getJavaClassName(int jdbcSQLType) {
-    	String className = NAME_TO_CLASSNAME.get(getTypeName(jdbcSQLType));
+    	TypeInfo typeInfo = TYPE_TO_TYPEINFO.get(jdbcSQLType);
     	
-    	if (className == null) {
-    		return OBJECT_CLASS;
+    	if (typeInfo == null) {
+    		return DataTypeManager.DefaultDataClasses.OBJECT.getName();
     	}
     	
-    	return className;
+    	return typeInfo.javaClassName;
     }
     
     public static final String getTypeName(int sqlType) {
-    	String name = TYPE_TO_NAME_MAP.get(sqlType);
+    	TypeInfo typeInfo = TYPE_TO_TYPEINFO.get(sqlType);
     	
-    	if (name == null) {
-    		return OBJECT;
+    	if (typeInfo == null) {
+    		return DataTypeManager.DefaultDataTypes.OBJECT;
     	}
     	
-    	return name;
+    	return typeInfo.name;
     }
 
-    public static String[] getMMTypeNames() {
-        return new String[] {
-            STRING,
-            BOOLEAN,
-            TIME,
-            DATE,
-            TIMESTAMP,
-            INTEGER,
-            FLOAT,
-            DOUBLE,
-            BIGDECIMAL,
-            BIGINTEGER,
-            BYTE,
-            SHORT,
-            LONG,
-            CHAR,
-            OBJECT,
-            CLOB,
-            BLOB,
-            XML
-        };
+    public static Set<String> getMMTypeNames() {
+    	return NAME_TO_TYPEINFO.keySet();
     }
 
+	public static Integer getMaxDisplaySize(Class<?> dataTypeClass) {
+	    return getMaxDisplaySize(DataTypeManager.getDataTypeName(dataTypeClass));
+	}
+
+	public static Integer getMaxDisplaySize(String typeName) {
+		TypeInfo ti = NAME_TO_TYPEINFO.get(typeName);
+		if (ti == null) {
+			return null;
+		}
+	    return ti.maxDisplaySize;
+	}
+
+	public static Integer getDefaultPrecision(Class<?> dataTypeClass) {
+	    return getDefaultPrecision(DataTypeManager.getDataTypeName(dataTypeClass));
+	}
+
+	public static Integer getDefaultPrecision(String typeName) {
+		TypeInfo ti = NAME_TO_TYPEINFO.get(typeName);
+		if (ti == null) {
+			return null;
+		}
+	    return ti.defaultPrecision;
+	}
+
 }
Index: runtime/src/main/java/org/teiid/deployers/VDBRepository.java
===================================================================
--- runtime/src/main/java/org/teiid/deployers/VDBRepository.java	(revision 3801)
+++ runtime/src/main/java/org/teiid/deployers/VDBRepository.java	(working copy)
@@ -55,6 +55,7 @@
 	private List<VDBLifeCycleListener> listeners = new CopyOnWriteArrayList<VDBLifeCycleListener>();
 	private SystemFunctionManager systemFunctionManager;
 	private MetadataRepository metadataRepository;
+	private Map<String, Datatype> datatypeMap = new HashMap<String, Datatype>();
 	
 	public MetadataRepository getMetadataRepository() {
 		return metadataRepository;
@@ -224,6 +225,15 @@
 	
 	public void setSystemStore(MetadataStore store) {
 		this.systemStore = store;
+		Collection<Datatype> datatypes = this.systemStore.getDatatypes();
+		for (Class<?> typeClass : DataTypeManager.getAllDataTypeClasses()) {
+			for (Datatype datatypeRecordImpl : datatypes) {
+				if (datatypeRecordImpl.getJavaClassName().equals(typeClass.getName())) {
+					datatypeMap.put(DataTypeManager.getDataTypeName(typeClass), datatypeRecordImpl);
+					break;
+				}
+			}
+		}
 	}
 	
 	public void setMetadataRepository(MetadataRepository metadataRepository) {
@@ -265,16 +275,6 @@
 	}	
 	
 	public Map<String, Datatype> getBuiltinDatatypes() {
-		Collection<Datatype> datatypes = this.systemStore.getDatatypes();
-		Map<String, Datatype> datatypeMap = new HashMap<String, Datatype>();
-		for (Class<?> typeClass : DataTypeManager.getAllDataTypeClasses()) {
-			for (Datatype datatypeRecordImpl : datatypes) {
-				if (datatypeRecordImpl.getJavaClassName().equals(typeClass.getName())) {
-					datatypeMap.put(DataTypeManager.getDataTypeName(typeClass), datatypeRecordImpl);
-					break;
-				}
-			}
-		}
 		return datatypeMap;
 	}
 	
Index: client/src/main/java/org/teiid/jdbc/DataTypeTransformer.java
===================================================================
--- client/src/main/java/org/teiid/jdbc/DataTypeTransformer.java	(revision 3801)
+++ client/src/main/java/org/teiid/jdbc/DataTypeTransformer.java	(working copy)
@@ -41,6 +41,7 @@
 import java.sql.Time;
 import java.sql.Timestamp;
 
+import org.teiid.core.types.BinaryType;
 import org.teiid.core.types.DataTypeManager;
 import org.teiid.core.types.TransformationException;
 import org.teiid.core.types.DataTypeManager.DefaultDataClasses;
@@ -127,6 +128,8 @@
             return blob.getBytes(1, (int)length);
         } else if (value instanceof String) {
         	return ((String)value).getBytes();
+        } else if (value instanceof BinaryType) {
+        	return ((BinaryType)value).getBytesDirect();
         }
         throw new TeiidSQLException(JDBCPlugin.Util.getString("DataTypeTransformer.cannot_get_bytes")); //$NON-NLS-1$
     }
Index: client/src/test/java/org/teiid/client/TestBatchSerializer.java
===================================================================
--- client/src/test/java/org/teiid/client/TestBatchSerializer.java	(revision 3801)
+++ client/src/test/java/org/teiid/client/TestBatchSerializer.java	(working copy)
@@ -34,6 +34,7 @@
 
 import junit.framework.TestCase;
 
+import org.teiid.core.types.BinaryType;
 import org.teiid.core.types.DataTypeManager;
 import org.teiid.core.util.TimestampWithTimezone;
 
@@ -78,6 +79,7 @@
                                                       DataTypeManager.DefaultDataTypes.TIME,
                                                       DataTypeManager.DefaultDataTypes.TIMESTAMP,
                                                       DataTypeManager.DefaultDataTypes.OBJECT,
+                                                      DataTypeManager.DefaultDataTypes.VARBINARY,
                                                      };
     private static String sampleString(int length) {
         char[] chars = new char[length];
@@ -92,7 +94,7 @@
         
         for (int i = 0; i < rows; i++) {
         	java.util.Date d = new java.util.Date();
-            int mod = i%14;
+            int mod = i%16;
             Object[] data = { (mod == 0) ? null : new BigDecimal("" + i), //$NON-NLS-1$
                               (mod == 1) ? null : new BigInteger(Integer.toString(i)),
                               (mod == 2) ? null : ((i%2 == 0) ? Boolean.FALSE: Boolean.TRUE),
@@ -108,6 +110,7 @@
                               (mod == 12) ? null : TimestampWithTimezone.createTime(d),
                               (mod == 13) ? null : TimestampWithTimezone.createTimestamp(d),
                               (mod == 14) ? null : TimestampWithTimezone.createTimestamp(d),
+                    		  (mod == 15) ? null : new BinaryType(new byte[] {(byte)i}),
                             };
             batch[i] = Arrays.asList(data);
         }
Index: client/src/main/java/org/teiid/jdbc/PreparedStatementImpl.java
===================================================================
--- client/src/main/java/org/teiid/jdbc/PreparedStatementImpl.java	(revision 3801)
+++ client/src/main/java/org/teiid/jdbc/PreparedStatementImpl.java	(working copy)
@@ -37,8 +37,6 @@
 import java.util.TimeZone;
 import java.util.TreeMap;
 
-import javax.sql.rowset.serial.SerialBlob;
-
 import org.teiid.client.RequestMessage;
 import org.teiid.client.RequestMessage.ResultsMode;
 import org.teiid.client.RequestMessage.StatementType;
@@ -48,6 +46,7 @@
 import org.teiid.core.TeiidProcessingException;
 import org.teiid.core.types.BlobImpl;
 import org.teiid.core.types.ClobImpl;
+import org.teiid.core.types.DataTypeManager;
 import org.teiid.core.types.InputStreamFactory;
 import org.teiid.core.types.JDBCSQLTypeInfo;
 import org.teiid.core.types.Streamable;
@@ -298,7 +297,7 @@
     }
 
     public void setBytes(int parameterIndex, byte bytes[]) throws SQLException {
-    	setObject(parameterIndex, new SerialBlob(bytes));
+    	setObject(parameterIndex, bytes);
     }
 
     public void setCharacterStream (int parameterIndex, java.io.Reader reader, int length) throws SQLException {
@@ -379,7 +378,7 @@
     }
 
     void setObject(Object parameterIndex, Object value, int targetJdbcType) throws SQLException {
-        Object targetObject = null;
+        Object targetObject = value;
 
         if(value == null) {
             setObject(parameterIndex, null);
@@ -387,45 +386,61 @@
         }
 
         // get the java class name for the given JDBC type
-        String javaClassName = JDBCSQLTypeInfo.getJavaClassName(targetJdbcType);
+        String typeName = JDBCSQLTypeInfo.getTypeName(targetJdbcType);
+        int typeCode = DataTypeManager.getTypeCode(DataTypeManager.getDataTypeClass(typeName));
         // transform the value to the target datatype
-        if (targetJdbcType == Types.JAVA_OBJECT) {
-        	targetObject = value;
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.STRING_CLASS)) {
-            targetObject = DataTypeTransformer.getString(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.CHAR_CLASS)) {
-            targetObject = DataTypeTransformer.getCharacter(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.INTEGER_CLASS)) {
-            targetObject = DataTypeTransformer.getInteger(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.BYTE_CLASS)) {
-            targetObject = DataTypeTransformer.getByte(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.SHORT_CLASS)) {
-            targetObject = DataTypeTransformer.getShort(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.LONG_CLASS)) {
-            targetObject = DataTypeTransformer.getLong(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.FLOAT_CLASS)) {
-            targetObject = DataTypeTransformer.getFloat(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.DOUBLE_CLASS)) {
-            targetObject = DataTypeTransformer.getDouble(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.BOOLEAN_CLASS)) {
-            targetObject = DataTypeTransformer.getBoolean(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.BIGDECIMAL_CLASS)) {
-            targetObject = DataTypeTransformer.getBigDecimal(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.TIMESTAMP_CLASS)) {
-            targetObject = DataTypeTransformer.getTimestamp(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.DATE_CLASS)) {
-            targetObject = DataTypeTransformer.getDate(value);
-        } else if(javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.TIME_CLASS)) {
-            targetObject = DataTypeTransformer.getTime(value);
-        } else if (javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.BLOB_CLASS)) {
-            targetObject = DataTypeTransformer.getBlob(value);
-        } else if (javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.CLOB_CLASS)) {
-            targetObject = DataTypeTransformer.getClob(value);
-        } else if (javaClassName.equalsIgnoreCase(JDBCSQLTypeInfo.XML_CLASS)) {
+        switch (typeCode) {
+        case DataTypeManager.DefaultTypeCodes.STRING:
+        	targetObject = DataTypeTransformer.getString(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.CHAR:
+        	targetObject = DataTypeTransformer.getCharacter(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.INTEGER:
+        	targetObject = DataTypeTransformer.getInteger(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.BYTE:
+        	targetObject = DataTypeTransformer.getByte(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.SHORT:
+        	targetObject = DataTypeTransformer.getShort(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.LONG:
+        	targetObject = DataTypeTransformer.getLong(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.FLOAT:
+        	targetObject = DataTypeTransformer.getFloat(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.DOUBLE:
+        	targetObject = DataTypeTransformer.getDouble(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.BOOLEAN:
+        	targetObject = DataTypeTransformer.getBoolean(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.BIGDECIMAL:
+        	targetObject = DataTypeTransformer.getBigDecimal(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.TIMESTAMP:
+        	targetObject = DataTypeTransformer.getTimestamp(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.DATE:
+        	targetObject = DataTypeTransformer.getDate(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.TIME:
+        	targetObject = DataTypeTransformer.getTime(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.BLOB:
+        	targetObject = DataTypeTransformer.getBlob(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.CLOB:
+        	targetObject = DataTypeTransformer.getClob(value);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.XML:
         	targetObject = DataTypeTransformer.getSQLXML(value);
-        } else {
-            String msg = JDBCPlugin.Util.getString("MMPreparedStatement.Err_transform_obj"); //$NON-NLS-1$
-            throw new TeiidSQLException(msg);
+        	break;
+        case DataTypeManager.DefaultTypeCodes.VARBINARY:
+        	targetObject = DataTypeTransformer.getBytes(value);
+        	break;
         }
 
         setObject(parameterIndex, targetObject);
